=begin
Copyright 2010 Vincent Carmona
vinc4mai+taglib@gmail.com

This file is part of ruby-taglib2.

    ruby-taglib2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ruby-taglib2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ruby-taglib2; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
=end

require "test/unit"
require 'ftools'

class Test::Unit::TestSuite
	alias :old_testunit_run_for_taglib2 :run
	def run(result, &progress_block)
		setup if respond_to?(:setup)
		old_testunit_run_for_taglib2(result, &progress_block)
		teardown if respond_to?(:teardown)
	end
end

class TaglibTestsUtil
	dir=File.expand_path(File.dirname(__FILE__))
	@@tmp=File.join(dir, 'tmp')
	@@read=File.join(@@tmp, 'read.wav')
	@@empty=File.join(@@tmp, 'empty')
	@@write=File.join(@@tmp, 'write.wav')
	@@exceptions=File.join(@@tmp, 'exceptions.ogg')

	def TaglibTestsUtil.tmp
		@@tmp
	end

	def TaglibTestsUtil.read
		@@read
	end

	def TaglibTestsUtil.empty
		@@empty
	end

	def TaglibTestsUtil.write
		@@write
	end

	def TaglibTestsUtil.exceptions
		@@exceptions
	end

	def TaglibTestsUtil.clean
		if File.exists?(@@tmp)
			File.delete(*Dir.glob(File.join(@@tmp, '*')))
			Dir.rmdir(@@tmp)
		end
	end

	def TaglibTestsUtil.setup
		data=File.join(@@tmp, '..', 'data')
		TaglibTestsUtil.clean
		File.makedirs(@@tmp)
		File.copy(File.join(data, 'silence.wav'), @@read)
		File.copy(File.join(data, 'empty'), @@empty)
		File.copy(File.join(data, 'silence.wav'), @@write)
		File.copy(File.join(data, 'exceptions.ogg'), @@exceptions)
	end

	def TaglibTestsUtil.teardown
		TaglibTestsUtil.clean
	end
end

dir=File.expand_path(File.join(File.dirname(__FILE__), ".."))
$:.unshift(dir)
$:.unshift(File.join(dir, 'lib'))
if ARGV.include?('--compat')
	ARGV.delete('--compat')
	$:.unshift(File.join(dir, 'compat'))
	require 'taglib'
	require 'tests/compat'
else
	require "taglib2"
end
require 'tests/constants'
require 'tests/exceptions'
require 'tests/file'
